## bpfcc 0.5.0

=== CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")
cmake_minimum_required(VERSION 2.8.7)

project(bcc)
if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

enable_testing()

include(cmake/GetGitRevisionDescription.cmake)
include(cmake/version.cmake)
include(CMakeDependentOption)
include(GNUInstallDirs)
include(CheckCXXCompilerFlag)
include(cmake/FindCompilerFlag.cmake)

option(ENABLE_CLANG_JIT "Enable Loading BPF through Clang Frontend" ON)
option(ENABLE_USDT "Enable User-level Statically Defined Tracing" ON)
CMAKE_DEPENDENT_OPTION(ENABLE_CPP_API "Enable C++ API" ON "ENABLE_USDT" OFF)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

if(NOT PYTHON_ONLY AND ENABLE_CLANG_JIT)
find_package(BISON)
find_package(FLEX)
find_package(LLVM REQUIRED CONFIG)
message(STATUS "Found LLVM: ${LLVM_INCLUDE_DIRS} ${LLVM_PACKAGE_VERSION}")
find_package(LibElf REQUIRED)

# clang is linked as a library, but the library path searching is
# primitively supported, unlike libLLVM
set(CLANG_SEARCH "/opt/local/llvm/lib;/usr/lib/llvm-3.7/lib;${LLVM_LIBRARY_DIRS}")
find_library(libclangAnalysis NAMES clangAnalysis HINTS ${CLANG_SEARCH})
find_library(libclangAST NAMES clangAST HINTS ${CLANG_SEARCH})
find_library(libclangBasic NAMES clangBasic HINTS ${CLANG_SEARCH})
find_library(libclangCodeGen NAMES clangCodeGen HINTS ${CLANG_SEARCH})
find_library(libclangDriver NAMES clangDriver HINTS ${CLANG_SEARCH})
find_library(libclangEdit NAMES clangEdit HINTS ${CLANG_SEARCH})
find_library(libclangFrontend NAMES clangFrontend HINTS ${CLANG_SEARCH})
find_library(libclangLex NAMES clangLex HINTS ${CLANG_SEARCH})
find_library(libclangParse NAMES clangParse HINTS ${CLANG_SEARCH})
find_library(libclangRewrite NAMES clangRewrite HINTS ${CLANG_SEARCH})
find_library(libclangSema NAMES clangSema HINTS ${CLANG_SEARCH})
find_library(libclangSerialization NAMES clangSerialization HINTS ${CLANG_SEARCH})
if(libclangBasic STREQUAL "libclangBasic-NOTFOUND")
  message(FATAL_ERROR "Unable to find clang libraries")
endif()
FOREACH(DIR ${LLVM_INCLUDE_DIRS})
  include_directories("${DIR}/../tools/clang/include")
ENDFOREACH()

# Set to a string path if system places kernel lib directory in
# non-default location.
if(NOT DEFINED BCC_KERNEL_MODULES_DIR)
  set(BCC_KERNEL_MODULES_DIR "/lib/modules")
endif()

if(NOT DEFINED BCC_PROG_TAG_DIR)
  set(BCC_PROG_TAG_DIR "/var/tmp/bcc")
endif()

# As reported in issue #735, GCC 6 has some behavioral problems when
# dealing with -isystem. Hence, skip the warning optimization
# altogether on that compiler.
option(USINGISYSTEM "using -isystem" ON)
execute_process(COMMAND ${CMAKE_C_COMPILER} -dumpversion OUTPUT_VARIABLE GCC_VERSION)
if (USINGISYSTEM AND GCC_VERSION VERSION_LESS 6.0)
  # iterate over all available directories in LLVM_INCLUDE_DIRS to
  # generate a correctly tokenized list of parameters
  foreach(ONE_LLVM_INCLUDE_DIR ${LLVM_INCLUDE_DIRS})
    set(CXX_ISYSTEM_DIRS "${CXX_ISYSTEM_DIRS} -isystem ${ONE_LLVM_INCLUDE_DIR}")
  endforeach()
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 11)

endif(NOT PYTHON_ONLY AND ENABLE_CLANG_JIT)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall ${CXX_ISYSTEM_DIRS}")

add_subdirectory(src)
add_subdirectory(introspection)
if(ENABLE_CLANG_JIT)
add_subdirectory(examples)
add_subdirectory(man)
add_subdirectory(tests)
add_subdirectory(tools)
endif(ENABLE_CLANG_JIT)

=== examples/CMakeLists.txt ===
set(EXAMPLE_PROGRAMS hello_world.py)
install(PROGRAMS ${EXAMPLE_PROGRAMS} DESTINATION share/bcc/examples)

if(ENABLE_CLANG_JIT)
if(ENABLE_USDT)
add_subdirectory(cpp)
endif(ENABLE_USDT)
add_subdirectory(lua)
add_subdirectory(networking)
add_subdirectory(tracing)
endif()

=== introspection/CMakeLists.txt ===
# Copyright (c) Facebook, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

include_directories(${CMAKE_SOURCE_DIR}/src/cc)
include_directories(${CMAKE_SOURCE_DIR}/src/cc/api)

option(INSTALL_INTROSPECTION "Install BPF introspection tools" ON)

add_executable(bps bps.c)
target_link_libraries(bps bcc-static)

install (TARGETS bps DESTINATION share/bcc/introspection)

=== snapcraft/Makefile ===
#
# Copyright (C) 2016 Canonical
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#

#
# Simple makefile to mangle version info in the yaml file
#
VERSION=$(shell git tag | tail -1 | cut -c2-)
COMMITS=$(shell git log --oneline | wc -l)
SHA=$(shell git log -1 --oneline | cut -d' ' -f1)
DATE=$(shell date +'%Y%m%d')
V=$(VERSION)-$(DATE)-$(COMMITS)-$(SHA)

all: set_version
	snapcraft

set_version:
	cat snapcraft.yaml | sed 's/version: .*/version: $(V)/' > snapcraft-tmp.yaml
	mv snapcraft-tmp.yaml snapcraft.yaml

install:
	#
	# Install latest snap
	#
	sudo snap install --devmode bcc_*.snap

	#
	# Connect up interfaces
	#
	sudo snap connect bcc:mount-observe
	sudo snap connect bcc:system-observe
	sudo snap connect bcc:system-trace

remove:
	sudo snap remove bcc

clean:
	snapcraft clean
	rm -rf setup *.snap snapcraft

=== tests/CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")
configure_file(wrapper.sh.in "${CMAKE_CURRENT_BINARY_DIR}/wrapper.sh" @ONLY)

set(TEST_WRAPPER ${CMAKE_CURRENT_BINARY_DIR}/wrapper.sh)

add_test(NAME style-check COMMAND ${CMAKE_SOURCE_DIR}/scripts/style-check.sh)
set_tests_properties(style-check PROPERTIES PASS_REGULAR_EXPRESSION ".*")

if(ENABLE_CLANG_JIT)
add_subdirectory(cc)
add_subdirectory(python)
add_subdirectory(lua)
endif()

=== examples/cpp/CMakeLists.txt ===
# Copyright (c) Facebook, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

include_directories(${CMAKE_SOURCE_DIR}/src/cc)
include_directories(${CMAKE_SOURCE_DIR}/src/cc/api)

option(INSTALL_CPP_EXAMPLES "Install C++ examples. Those binaries are statically linked and can take plenty of disk space" OFF)

add_executable(HelloWorld HelloWorld.cc)
target_link_libraries(HelloWorld bcc-static)

add_executable(CPUDistribution CPUDistribution.cc)
target_link_libraries(CPUDistribution bcc-static)

add_executable(RecordMySQLQuery RecordMySQLQuery.cc)
target_link_libraries(RecordMySQLQuery bcc-static)

add_executable(TCPSendStack TCPSendStack.cc)
target_link_libraries(TCPSendStack bcc-static)

add_executable(RandomRead RandomRead.cc)
target_link_libraries(RandomRead bcc-static)

add_executable(LLCStat LLCStat.cc)
target_link_libraries(LLCStat bcc-static)

add_executable(FollyRequestContextSwitch FollyRequestContextSwitch.cc)
target_link_libraries(FollyRequestContextSwitch bcc-static)

if(INSTALL_CPP_EXAMPLES)
  install (TARGETS HelloWorld DESTINATION share/bcc/examples/cpp)
  install (TARGETS CPUDistribution DESTINATION share/bcc/examples/cpp)
  install (TARGETS RecordMySQLQuery DESTINATION share/bcc/examples/cpp)
  install (TARGETS TCPSendStack DESTINATION share/bcc/examples/cpp)
  install (TARGETS RandomRead DESTINATION share/bcc/examples/cpp)
  install (TARGETS LLCStat DESTINATION share/bcc/examples/cpp)
  install (TARGETS FollyRequestContextSwitch DESTINATION share/bcc/examples/cpp)
endif(INSTALL_CPP_EXAMPLES)

=== man/man8/CMakeLists.txt ===
file(GLOB FILES *.8)
install(FILES ${FILES} DESTINATION share/bcc/man/man8)

=== src/cc/CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
# to be removed
include_directories(${CMAKE_CURRENT_BINARY_DIR}/frontends/b)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/frontends/b)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/frontends/clang)
include_directories(${LLVM_INCLUDE_DIRS})
include_directories(${LIBELF_INCLUDE_DIRS})
# todo: if check for kernel version
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/compat)
add_definitions(${LLVM_DEFINITIONS})
configure_file(libbcc.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libbcc.pc @ONLY)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fPIC -DBCC_PROG_TAG_DIR='\"${BCC_PROG_TAG_DIR}\"'")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC")

string(REGEX MATCH "^([0-9]+).*" _ ${LLVM_PACKAGE_VERSION})
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DLLVM_MAJOR_VERSION=${CMAKE_MATCH_1}")

include(static_libstdc++)

add_library(bpf-static STATIC libbpf.c perf_reader.c)
set_target_properties(bpf-static PROPERTIES OUTPUT_NAME bpf)
add_library(bpf-shared SHARED libbpf.c perf_reader.c)
set_target_properties(bpf-shared PROPERTIES VERSION ${REVISION_LAST} SOVERSION 0)
set_target_properties(bpf-shared PROPERTIES OUTPUT_NAME bpf)

set(bcc_common_sources bpf_common.cc bpf_module.cc exported_files.cc)
if (${LLVM_PACKAGE_VERSION} VERSION_GREATER "5")
  set(bcc_common_sources ${bcc_common_sources} bcc_debug.cc)
endif()

set(bcc_table_sources table_storage.cc shared_table.cc bpffs_table.cc json_map_decl_visitor.cc)
set(bcc_util_sources ns_guard.cc common.cc)
set(bcc_sym_sources bcc_syms.cc bcc_elf.c bcc_perf_map.c bcc_proc.c)
set(bcc_common_headers libbpf.h perf_reader.h)
set(bcc_table_headers file_desc.h table_desc.h table_storage.h)
set(bcc_api_headers bpf_common.h bpf_module.h bcc_exception.h bcc_syms.h)

if(ENABLE_CLANG_JIT)
add_library(bcc-shared SHARED
  link_all.cc ${bcc_common_sources} ${bcc_table_sources} ${bcc_sym_sources}
  ${bcc_util_sources})
set_target_properties(bcc-shared PROPERTIES VERSION ${REVISION_LAST} SOVERSION 0)
set_target_properties(bcc-shared PROPERTIES OUTPUT_NAME bcc)

add_library(bcc-loader-static STATIC ${bcc_sym_sources} ${bcc_util_sources})
target_link_libraries(bcc-loader-static elf)
add_library(bcc-static STATIC
  ${bcc_common_sources} ${bcc_table_sources} ${bcc_util_sources})
set_target_properties(bcc-static PROPERTIES OUTPUT_NAME bcc)

include(clang_libs)
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${clang_lib_exclude_flags}")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${llvm_lib_exclude_flags}")

# bcc_common_libs_for_a for archive libraries
# bcc_common_libs_for_s for shared libraries
set(bcc_common_libs_for_a b_frontend clang_frontend bpf-static
  ${clang_libs} ${llvm_libs} ${LIBELF_LIBRARIES})
set(bcc_common_libs_for_s ${bcc_common_libs_for_a})

if(ENABLE_CPP_API)
  add_subdirectory(api)
  list(APPEND bcc_common_libs_for_a api-static)
  # Keep all API functions
  list(APPEND bcc_common_libs_for_s -Wl,--whole-archive api-static -Wl,--no-whole-archive)
endif()

if(ENABLE_USDT)
  add_subdirectory(usdt)
  list(APPEND bcc_common_libs_for_a usdt-static)
  list(APPEND bcc_common_libs_for_s usdt-static)
endif()

add_subdirectory(frontends)

# Link against LLVM libraries
target_link_libraries(bcc-shared ${bcc_common_libs_for_s})
target_link_libraries(bcc-static ${bcc_common_libs_for_a} bcc-loader-static)

install(TARGETS bcc-shared LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
install(FILES ${bcc_table_headers} DESTINATION include/bcc)
install(FILES ${bcc_api_headers} DESTINATION include/bcc)
install(DIRECTORY compat/linux/ DESTINATION include/bcc/compat/linux FILES_MATCHING PATTERN "*.h")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libbcc.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
endif(ENABLE_CLANG_JIT)
install(FILES ${bcc_common_headers} DESTINATION include/bcc)
install(TARGETS bpf-shared LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})

=== src/lua/CMakeLists.txt ===
find_package(LuaJIT)
find_program(LUAJIT luajit)

if (LUAJIT_LIBRARIES AND LUAJIT)
	FILE(GLOB_RECURSE SRC_LUA
		${CMAKE_CURRENT_SOURCE_DIR}/bcc/*.lua
		${CMAKE_CURRENT_SOURCE_DIR}/bcc/vendor/*.lua
		${CMAKE_CURRENT_SOURCE_DIR}/bpf/*.lua)

	ADD_CUSTOM_COMMAND(
		OUTPUT bcc.lua
		COMMAND ${LUAJIT} ${CMAKE_CURRENT_SOURCE_DIR}/src/squish.lua ${CMAKE_CURRENT_SOURCE_DIR}
		DEPENDS ${SRC_LUA} ${CMAKE_CURRENT_SOURCE_DIR}/squishy
	)

	ADD_CUSTOM_COMMAND(
		OUTPUT bcc.o
		COMMAND ${LUAJIT} -bg bcc.lua bcc.o
		DEPENDS bcc.lua
	)

	include_directories(${LUAJIT_INCLUDE_DIR})
	add_executable(bcc-lua src/main.c bcc.o)
	set_target_properties(bcc-lua PROPERTIES LINKER_LANGUAGE C)
	target_link_libraries(bcc-lua ${LUAJIT_LIBRARIES})
	target_link_libraries(bcc-lua -Wl,--whole-archive bcc-static -Wl,--no-whole-archive)
	if (NOT COMPILER_NOPIE_FLAG EQUAL "")
		target_link_libraries(bcc-lua ${COMPILER_NOPIE_FLAG})
	endif()

	install(TARGETS bcc-lua RUNTIME DESTINATION bin)
endif()

=== src/python/CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

macro(symlink_file SRC DST)
  execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${SRC} ${DST})
endmacro()

symlink_file(${CMAKE_CURRENT_SOURCE_DIR}/bcc ${CMAKE_CURRENT_BINARY_DIR}/bcc)

if(NOT PYTHON_CMD)
  set(PYTHON_CMD "python")
endif()

set(PIP_INSTALLABLE "${CMAKE_CURRENT_BINARY_DIR}/dist/bcc-${REVISION}.tar.gz")
configure_file(setup.py.in ${CMAKE_CURRENT_BINARY_DIR}/setup.py @ONLY)
# build the pip installable
add_custom_command(OUTPUT ${PIP_INSTALLABLE}
  COMMAND ${PYTHON_CMD} setup.py sdist
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/bcc/__init__.py ${CMAKE_CURRENT_BINARY_DIR}/setup.py
  )
add_custom_target(bcc_py ALL DEPENDS ${PIP_INSTALLABLE})

if(EXISTS "/etc/debian_version")
  set(PYTHON_FLAGS "${PYTHON_FLAGS} --install-layout deb")
endif()
install(CODE "execute_process(COMMAND ${PYTHON_CMD} setup.py install -f ${PYTHON_FLAGS}
  --prefix=${CMAKE_INSTALL_PREFIX} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})"
  COMPONENT python)

=== tests/cc/CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

include_directories(${CMAKE_SOURCE_DIR}/src/cc)
include_directories(${CMAKE_SOURCE_DIR}/src/cc/api)

add_executable(test_static test_static.c)
target_link_libraries(test_static bcc-static)

add_test(NAME c_test_static COMMAND ${TEST_WRAPPER} c_test_static sudo ${CMAKE_CURRENT_BINARY_DIR}/test_static)

if(ENABLE_USDT)
add_executable(test_libbcc
	test_libbcc.cc
	test_c_api.cc
	test_array_table.cc
	test_bpf_table.cc
	test_hash_table.cc
	test_usdt_args.cc
	test_usdt_probes.cc
	utils.cc)

target_link_libraries(test_libbcc bcc-shared dl)
add_test(NAME test_libbcc COMMAND ${TEST_WRAPPER} c_test_all sudo ${CMAKE_CURRENT_BINARY_DIR}/test_libbcc)

find_path(SDT_HEADER NAMES "sys/sdt.h")
if (SDT_HEADER)
	target_compile_definitions(test_libbcc PRIVATE HAVE_SDT_HEADER=1)
endif()
endif(ENABLE_USDT)

=== tests/lua/CMakeLists.txt ===
find_program(LUAJIT luajit)
find_program(BUSTED busted)

if(LUAJIT)
	add_test(NAME lua_test_clang WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMAND ${TEST_WRAPPER} lua_test_clang sudo ${LUAJIT} test_clang.lua)

	add_test(NAME lua_test_uprobes WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMAND ${TEST_WRAPPER} lua_test_uprobes sudo ${LUAJIT} test_uprobes.lua)

	add_test(NAME lua_test_dump WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
		COMMAND ${TEST_WRAPPER} lua_test_dump sudo ${LUAJIT} test_dump.lua)

	add_test(NAME lua_test_standalone WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
		COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test_standalone.sh)

	if(BUSTED)
		add_test(NAME lua_test_busted WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			COMMAND busted --lua=${LUAJIT} -m "${CMAKE_CURRENT_SOURCE_DIR}/../../src/lua/?.lua" -m "${CMAKE_CURRENT_SOURCE_DIR}/../../src/lua/?/init.lua;")
	endif()
endif()

=== debian/changelog ===
bpfcc (0.5.0-5ubuntu1) bionic; urgency=medium

  * Merge from Debian unstable.  Remaining changes:
    - Use llvm 4.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 27 Mar 2018 10:00:50 +0200

bpfcc (0.5.0-5) unstable; urgency=medium

  * Add python3 bpfcc package. Thanks to Andreas Gerstmayr
  * Add python3-distutils to build dependency (Closes: #893434)
  * Add missing debian documents (Closes: #891035)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 23 Mar 2018 15:20:13 +0530

bpfcc (0.5.0-4ubuntu2) bionic; urgency=medium

  * Fixup previous merge 

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Feb 2018 10:44:30 +0100

bpfcc (0.5.0-4ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Use llvm 4.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 21 Feb 2018 10:39:48 +0100

bpfcc (0.5.0-4) unstable; urgency=medium

  * Check for file type before renaming (Closes: #890686)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 20 Feb 2018 15:03:10 +0530

bpfcc (0.5.0-3ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Use llvm 4.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 22 Dec 2017 11:56:35 +0100

bpfcc (0.5.0-3) unstable; urgency=medium

  * Extend libbpfcc to ppc64 too. And restrict bpfcc-lua to amd64 only

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 20 Dec 2017 21:35:42 +0530

bpfcc (0.5.0-2) unstable; urgency=medium

  * Really enable some 64bit architectures. We'll extend to other
    architectures only when upstream has readiness

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 19 Dec 2017 22:47:20 +0530

bpfcc (0.5.0-1ubuntu3) bionic; urgency=medium

  * Back to any, readd previous patch to fix build failures.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 18 Dec 2017 15:30:43 +0100

bpfcc (0.5.0-1ubuntu2) bionic; urgency=medium

  * Restrict lua binding to packages where lua is available

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 18 Dec 2017 15:07:46 +0100

bpfcc (0.5.0-1ubuntu1) bionic; urgency=medium

  * Merge from Debian unstable, remaining changes:
    - Fixup 64bit architectures list
    - Use llvm 4.0

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 18 Dec 2017 14:17:26 +0100

bpfcc (0.5.0-1) unstable; urgency=medium

  * New upstream version 0.5.0
  * Drop architecture support to 64bit common architectures only
    (Closes: #882344)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 17 Dec 2017 18:19:44 +0530

bpfcc (0.4.0-1ubuntu3) bionic; urgency=high

  * Comment out test that only works on amd64 and ppc64el.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Tue, 28 Nov 2017 20:55:32 -0600

bpfcc (0.4.0-1ubuntu2) bionic; urgency=medium

  * Set version dependencies on libllvm-dev and libclang-dev because Ubuntu's
    llvm-defaults uses 5.0 (of both) and this package isn't compatible with
    those versions quite yet.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 22 Nov 2017 18:01:20 -0600

bpfcc (0.4.0-1ubuntu1) bionic; urgency=high

  * Set version dependencies on libllvm-dev and libclang-dev because Ubuntu's
    llvm-defaults uses 5.0 (of both) and this package isn't compatible with
    those versions quite yet.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 22 Nov 2017 17:40:57 -0600

bpfcc (0.4.0-1) unstable; urgency=medium

  [ Edward Betts ]
  * correct spelling mistake

  [ Ritesh Raj Sarraf ]
  * Fix FTBFS with clang 4.0.
    Thanks to Sylvestre Ledru (Closes: 882160)
  * New upstream version 0.4.0
  * Disable User-level Statically Defined Tracing
  * Fix patches
  * Revert "Disable User-level Statically Defined Tracing"
  * Check manpage file's existence. For now, this will only honor
    regular manpages, and not symlinks

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 21 Nov 2017 19:16:03 +0530

=== debian/control ===
Source: bpfcc
Maintainer: Ritesh Raj Sarraf <rrs@debian.org>
Section: misc
Priority: optional
Standards-Version: 3.9.8
Build-Depends: arping,
	       bison,
               clang-format,
               cmake,
               debhelper (>= 11),
               dh-python,
               dpkg-dev (>= 1.16.1~),
               ethtool,
               flex,
               inetutils-ping | iputils-ping,
               iperf,
               libclang-4.0-dev,
               libedit-dev,
               libelf-dev,
               libfl-dev,
               libzip-dev,
               llvm-4.0-dev,
               libluajit-5.1-dev [amd64 armel armhf i386 mips mipsel powerpc],
               luajit [amd64 armel armhf i386 mips mipsel powerpc],
               python-netaddr,
               python-pyroute2,
               python3-distutils,
               python:any | python-all:any | python-dev:any | python-all-dev:any,
               python3:any | python3-all:any | python3-dev:any | python3-all-dev:any
Homepage: https://github.com/iovisor/bcc
Vcs-Git: https://anonscm.debian.org/git/collab-maint/bpfcc.git
Vcs-Browser: https://anonscm.debian.org/git/collab-maint/bpfcc.git

Package: libbpfcc
Architecture: amd64 arm64 ppc64el ppc64
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: shared library for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the shared library for BPF Compiler Collection
 to control BPF programs from userspace.

Package: libbpfcc-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}, libbpfcc (>= ${binary:Version})
Description: shared library for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the development headers for BPF Compiler Collection

Package: python-bpfcc
Architecture: all
Section: python
Depends: libbpfcc (>= ${binary:Version}), ${misc:Depends}, ${python:Depends}
Description: Python wrappers for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the Python bindings

Package: python3-bpfcc
Architecture: all
Section: python
Depends: libbpfcc (>= ${binary:Version}), ${misc:Depends}, ${python3:Depends}
Description: Python 3 wrappers for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the Python 3 bindings

Package: bpfcc-tools
Architecture: all
Depends: python-bpfcc (>= ${binary:Version}),
         python-netaddr,
         ${misc:Depends},
         ${python:Depends}
Description: tools for BPF Compiler Collection (BCC)
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the command-line tools and examples

Package: bpfcc-lua
Architecture: amd64
Depends: libbpfcc (>= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Standalone tool to run BCC tracers written in Lua
 BPF Compiler Collection (BCC) is a toolkit for creating efficient
 kernel tracing and manipulation programs
 .
 It makes use of extended BPF (Berkeley Package Filter) and provides tools
 for BPF based Linux IO analysis, networking, monitoring and more
 .
 This package provides the Lua bindings

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

CFLAGS=$(shell dpkg-buildflags --get CFLAGS) -no-pie
CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS) -no-pie

%:
	dh $@ --buildsystem=cmake --parallel --with python2,python3

override_dh_auto_configure:
	dh_auto_configure -- -DREVISION_LAST=$(DEB_VERSION_UPSTREAM) -DREVISION=$(DEB_VERSION_UPSTREAM) -DLLVM_DEFINITIONS="-D_GNU_SOURCE -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS" -DBCC_KERNEL_HAS_SOURCE_DIR=1 -DPYTHON_CMD="python2;python3"


override_dh_auto_install:
	dh_auto_install
	test -d $(CURDIR)/debian/tmp/usr/share/bcc/tools/doc && mv $(CURDIR)/debian/tmp/usr/share/bcc/tools/doc/* $(CURDIR)/debian/tmp/usr/share/bcc/doc/ && rm -d $(CURDIR)/debian/tmp/usr/share/bcc/tools/doc

	for eachFile in $(CURDIR)/debian/tmp/usr/share/bcc/tools/* ; do \
	    test -f  $$eachFile && mv $$eachFile $$eachFile-bpfcc ; \
	done

	for eachMan in $(CURDIR)/debian/tmp/usr/share/bcc/man/man8/* ; do \
	    test -f $$eachMan && manPage=`basename $$eachMan | cut -d "." -f1`; \
	    mv $$eachMan $(CURDIR)/debian/tmp/usr/share/bcc/man/man8/$$manPage-bpfcc.8 ; \
	done

override_dh_installdocs:
	dh_installdocs -A debian/README.Debian


override_dh_auto_test:
	@# We can't really run root privilege tests in build env
	# do not run tests

## bpfcc 0.6.0

=== src/cc/CMakeLists.txt ===
--- 
+++ 
@@ -29,7 +29,7 @@
 set_target_properties(bpf-shared PROPERTIES OUTPUT_NAME bpf)
 
 set(bcc_common_sources bpf_common.cc bpf_module.cc exported_files.cc)
-if (${LLVM_PACKAGE_VERSION} VERSION_GREATER "5")
+if (${LLVM_PACKAGE_VERSION} VERSION_EQUAL 6 OR ${LLVM_PACKAGE_VERSION} VERSION_GREATER 6)
   set(bcc_common_sources ${bcc_common_sources} bcc_debug.cc)
 endif()
 
@@ -52,6 +52,8 @@
 add_library(bcc-static STATIC
   ${bcc_common_sources} ${bcc_table_sources} ${bcc_util_sources})
 set_target_properties(bcc-static PROPERTIES OUTPUT_NAME bcc)
+set(bcc-lua-static
+  ${bcc_common_sources} ${bcc_table_sources} ${bcc_sym_sources} ${bcc_util_sources})
 
 include(clang_libs)
 set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${clang_lib_exclude_flags}")
@@ -60,8 +62,11 @@
 # bcc_common_libs_for_a for archive libraries
 # bcc_common_libs_for_s for shared libraries
 set(bcc_common_libs_for_a b_frontend clang_frontend bpf-static
+  -Wl,--whole-archive ${clang_libs} ${llvm_libs} -Wl,--no-whole-archive
+  ${LIBELF_LIBRARIES})
+set(bcc_common_libs_for_s ${bcc_common_libs_for_a})
+set(bcc_common_libs_for_lua b_frontend clang_frontend bpf-static
   ${clang_libs} ${llvm_libs} ${LIBELF_LIBRARIES})
-set(bcc_common_libs_for_s ${bcc_common_libs_for_a})
 
 if(ENABLE_CPP_API)
   add_subdirectory(api)
@@ -74,6 +79,7 @@
   add_subdirectory(usdt)
   list(APPEND bcc_common_libs_for_a usdt-static)
   list(APPEND bcc_common_libs_for_s usdt-static)
+  list(APPEND bcc_common_libs_for_lua usdt-static)
 endif()
 
 add_subdirectory(frontends)
@@ -81,6 +87,7 @@
 # Link against LLVM libraries
 target_link_libraries(bcc-shared ${bcc_common_libs_for_s})
 target_link_libraries(bcc-static ${bcc_common_libs_for_a} bcc-loader-static)
+set(bcc-lua-static ${bcc-lua-static} ${bcc_common_libs_for_lua})
 
 install(TARGETS bcc-shared LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
 install(FILES ${bcc_table_headers} DESTINATION include/bcc)

=== src/python/CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

macro(symlink_file SRC DST)
  execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink ${SRC} ${DST})
endmacro()

symlink_file(${CMAKE_CURRENT_SOURCE_DIR}/bcc ${CMAKE_CURRENT_BINARY_DIR}/bcc)

if(NOT PYTHON_CMD)
  set(PYTHON_CMD "python")
endif()

configure_file(setup.py.in ${CMAKE_CURRENT_BINARY_DIR}/setup.py @ONLY)
if(EXISTS "/etc/debian_version")
  set(PYTHON_FLAGS "${PYTHON_FLAGS} --install-layout deb")
endif()

foreach(PY_CMD ${PYTHON_CMD})
  string(REPLACE "/" "-" PY_CMD_ESCAPED ${PY_CMD})

  set(PIP_INSTALLABLE "${CMAKE_CURRENT_BINARY_DIR}/dist-${PY_CMD_ESCAPED}/bcc-${REVISION}.tar.gz")
  # build the pip installable
  add_custom_command(OUTPUT ${PIP_INSTALLABLE}
    COMMAND ${PY_CMD} setup.py sdist --dist-dir dist-${PY_CMD_ESCAPED}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/bcc/__init__.py ${CMAKE_CURRENT_BINARY_DIR}/setup.py
    )
  add_custom_target(bcc_py_${PY_CMD_ESCAPED} ALL DEPENDS ${PIP_INSTALLABLE})

  install(CODE "execute_process(COMMAND ${PY_CMD} setup.py install -f ${PYTHON_FLAGS}
    --prefix=${CMAKE_INSTALL_PREFIX} WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})"
    COMPONENT python)
endforeach()

=== tests/python/CMakeLists.txt ===
# Copyright (c) PLUMgrid, Inc.
# Licensed under the Apache License, Version 2.0 (the "License")

find_program(ARPING arping)
if(ARPING STREQUAL "ARPING-NOTFOUND")
  message(WARNING "Recommended test program 'arping' not found")
endif()
find_program(NETPERF netperf)
if(NETPERF STREQUAL "NETPERF-NOTFOUND")
  message(WARNING "Recommended test program 'netperf' not found")
endif()
find_program(IPERF iperf)
if(IPERF STREQUAL "IPERF-NOTFOUND")
  find_program(IPERF3 iperf3)
  if(IPERF3 STREQUAL "IPERF3-NOTFOUND")
    message(WARNING "Recommended test program 'iperf' or 'iperf3' not found")
  endif()
endif()

add_test(NAME py_test_stat1_b WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_stat1_b namespace ${CMAKE_CURRENT_SOURCE_DIR}/test_stat1.py test_stat1.b proto.b)
add_test(NAME py_test_bpf_log WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_bpf_prog sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_bpf_log.py)
add_test(NAME py_test_stat1_c WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_stat1_c namespace ${CMAKE_CURRENT_SOURCE_DIR}/test_stat1.py test_stat1.c)
#add_test(NAME py_test_xlate1_b WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
#  COMMAND ${TEST_WRAPPER} py_xlate1_b namespace ${CMAKE_CURRENT_SOURCE_DIR}/test_xlate1.py test_xlate1.b proto.b)
add_test(NAME py_test_xlate1_c WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_xlate1_c namespace ${CMAKE_CURRENT_SOURCE_DIR}/test_xlate1.py test_xlate1.c)
add_test(NAME py_test_call1 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_call1_c namespace ${CMAKE_CURRENT_SOURCE_DIR}/test_call1.py test_call1.c)
add_test(NAME py_test_trace1 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_trace1 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_trace1.py test_trace1.b kprobe.b)
add_test(NAME py_test_trace2 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_trace2 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_trace2.py)
add_test(NAME py_test_trace3_c WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_trace3_c sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_trace3.py test_trace3.c)
add_test(NAME py_test_trace4 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_trace4 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_trace4.py)
add_test(NAME py_test_probe_count WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_probe_count sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_probe_count.py)
add_test(NAME py_test_debuginfo WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_debuginfo sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_debuginfo.py)
add_test(NAME py_test_brb WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_brb_c sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_brb.py test_brb.c)
add_test(NAME py_test_brb2 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_brb2_c sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_brb2.py test_brb2.c)
add_test(NAME py_test_clang WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_clang sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_clang.py)
add_test(NAME py_test_histogram WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_histogram sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_histogram.py)
add_test(NAME py_array WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_array sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_array.py)
add_test(NAME py_uprobes WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_uprobes sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_uprobes.py)
add_test(NAME py_test_stackid WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_stackid sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_stackid.py)
add_test(NAME py_test_tracepoint WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_tracepoint sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_tracepoint.py)
add_test(NAME py_test_perf_event WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_perf_event sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_perf_event.py)
add_test(NAME py_test_utils WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_utils sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_utils.py)
add_test(NAME py_test_percpu WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_percpu sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_percpu.py)
add_test(NAME py_test_dump_func WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_dump_func simple ${CMAKE_CURRENT_SOURCE_DIR}/test_dump_func.py)
add_test(NAME py_test_tools_smoke WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_tools_smoke sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_tools_smoke.py)
add_test(NAME py_test_tools_memleak WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_tools_memleak sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_tools_memleak.py)
add_test(NAME py_test_usdt WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_usdt sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_usdt.py)
add_test(NAME py_test_usdt2 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_usdt2 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_usdt2.py)
add_test(NAME py_test_usdt3 WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  COMMAND ${TEST_WRAPPER} py_test_usdt3 sudo ${CMAKE_CURRENT_SOURCE_DIR}/test_usdt3.py)

=== debian/changelog ===
bpfcc (0.6.0-2) unstable; urgency=medium

  * Drop patch force-using-clang-4.0.diff (Closes: #906974)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 24 Aug 2018 16:23:15 +0545

bpfcc (0.6.0-1) unstable; urgency=medium

  * Bump to debhelper compatibility 11
  * Install files to all packages
  * Switch packaging repository to Salsa
  * New upstream version 0.6.0
  * Drop patch build-for-multiple-python-installations.diff.
    Merged upstream

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 15 Jun 2018 19:13:42 +0545

=== debian/control ===
--- 
+++ 
@@ -14,12 +14,12 @@
                flex,
                inetutils-ping | iputils-ping,
                iperf,
-               libclang-4.0-dev,
+               libclang-dev,
                libedit-dev,
                libelf-dev,
                libfl-dev,
                libzip-dev,
-               llvm-4.0-dev,
+               llvm-dev,
                libluajit-5.1-dev [amd64 armel armhf i386 mips mipsel powerpc],
                luajit [amd64 armel armhf i386 mips mipsel powerpc],
                python-netaddr,
@@ -28,8 +28,8 @@
                python:any | python-all:any | python-dev:any | python-all-dev:any,
                python3:any | python3-all:any | python3-dev:any | python3-all-dev:any
 Homepage: https://github.com/iovisor/bcc
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/bpfcc.git
-Vcs-Browser: https://anonscm.debian.org/git/collab-maint/bpfcc.git
+Vcs-Git: https://salsa.debian.org/debian/bpfcc.git
+Vcs-Browser: https://salsa.debian.org/debian/bpfcc.git
 
 Package: libbpfcc
 Architecture: amd64 arm64 ppc64el ppc64

## bpfcc 0.8.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -16,6 +16,9 @@
 include(CheckCXXCompilerFlag)
 include(cmake/FindCompilerFlag.cmake)
 
+option(ENABLE_LLVM_NATIVECODEGEN "Enable use of llvm nativecodegen module (needed by rw-engine)" ON)
+option(ENABLE_RTTI "Enable compiling with real time type information" OFF)
+option(ENABLE_LLVM_SHARED "Enable linking LLVM as a shared library" OFF)
 option(ENABLE_CLANG_JIT "Enable Loading BPF through Clang Frontend" ON)
 option(ENABLE_USDT "Enable User-level Statically Defined Tracing" ON)
 CMAKE_DEPENDENT_OPTION(ENABLE_CPP_API "Enable C++ API" ON "ENABLE_USDT" OFF)
@@ -44,6 +47,7 @@
 find_library(libclangRewrite NAMES clangRewrite HINTS ${CLANG_SEARCH})
 find_library(libclangSema NAMES clangSema HINTS ${CLANG_SEARCH})
 find_library(libclangSerialization NAMES clangSerialization HINTS ${CLANG_SEARCH})
+find_library(libclangASTMatchers NAMES clangASTMatchers HINTS ${CLANG_SEARCH})
 if(libclangBasic STREQUAL "libclangBasic-NOTFOUND")
   message(FATAL_ERROR "Unable to find clang libraries")
 endif()

=== debian/changelog ===
bpfcc (0.8.0-4) unstable; urgency=medium

  * [6bb6080] Fix .so and its symlink in their respective pacakges.
    Thanks to Vincent Bernat

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 04 Feb 2019 15:40:29 +0530

bpfcc (0.8.0-3) unstable; urgency=medium

  * [ae23e3f] Restrict architectures to what is currently buildable

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 03 Feb 2019 19:56:02 +0530

bpfcc (0.8.0-2) unstable; urgency=medium

  * [b8a9b76] Add .pc and .so files in -dev package.
    Thanks to Vincent Bernat (Closes: #921188)
  * [c1424ff] Set architecture dependent for the development package

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 03 Feb 2019 13:18:21 +0530

bpfcc (0.8.0-1) unstable; urgency=medium

  * [5228c2f] Add debian/watch file.
    Thanks to Michael Prokop
  * [1f9bead] Add debian/gbp.conf file
  * [b172968] New upstream version 0.8.0
  * [ad863b4] Drop patch fix-uint128-build-failure.patch
    Not needed anymore

 -- Ritesh Raj Sarraf <rrs@debian.org>  Fri, 01 Feb 2019 12:29:43 +0530

bpfcc (0.7.0-2) unstable; urgency=medium

  * Disable parallel builds.
    Thanks to Adrian Bunk and Bernhard Schmidt (Closes: #913609)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 29 Nov 2018 18:42:33 +0530

bpfcc (0.7.0-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/changelog: Remove trailing whitespaces

  [ Ritesh Raj Sarraf ]
  * New upstream version 0.7.0
  * Drop the (now)unnecessary --parallel argument

 -- Ritesh Raj Sarraf <rrs@debian.org>  Mon, 29 Oct 2018 19:47:53 +0530

=== debian/control ===
--- 
+++ 
@@ -45,9 +45,9 @@
  to control BPF programs from userspace.
 
 Package: libbpfcc-dev
-Architecture: all
+Architecture: amd64 arm64 ppc64el ppc64
 Section: libdevel
-Depends: ${misc:Depends}, libbpfcc (>= ${binary:Version})
+Depends: ${misc:Depends}, libbpfcc (>= ${binary:Version}), ${shlibs:Depends}
 Description: shared library for BPF Compiler Collection (BCC)
  BPF Compiler Collection (BCC) is a toolkit for creating efficient
  kernel tracing and manipulation programs

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 CXXFLAGS=$(shell dpkg-buildflags --get CXXFLAGS) -no-pie
 
 %:
-	dh $@ --buildsystem=cmake --parallel --with python2,python3
+	dh $@ --buildsystem=cmake --with python2,python3 --no-parallel
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DREVISION_LAST=$(DEB_VERSION_UPSTREAM) -DREVISION=$(DEB_VERSION_UPSTREAM) -DLLVM_DEFINITIONS="-D_GNU_SOURCE -D__STDC_CONSTANT_MACROS -D__STDC_FORMAT_MACROS -D__STDC_LIMIT_MACROS" -DBCC_KERNEL_HAS_SOURCE_DIR=1 -DPYTHON_CMD="python2;python3"
